(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,         
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

program CodeWrench;

uses
  Forms,
  IdComponent,
  frmcwBase in 'frmcwBase.pas' {FormBase},
  frmcwBaseDialog in 'frmcwBaseDialog.pas' {BaseDialogForm},
  frmcwCodeOptions in 'frmcwCodeOptions.pas' {CodeOptions},
  frmcwFind in 'frmcwFind.pas' {FindForm},
  frmcwMain in 'frmcwMain.pas' {MainForm},
  frmcwOpenURL in 'frmcwOpenURL.pas' {frmOpenURL},
  frmcwOptions in 'frmcwOptions.pas' {frmOptions},
  frmcwPrefixDlg in 'frmcwPrefixDlg.pas' {PrefixDlg},
  frmcwSystemOptions in 'frmcwSystemOptions.pas' {SystemOptionsForm},
  ucwAnalyzeParser in 'ucwAnalyzeParser.pas',
  ucwBuiltInReports in 'ucwBuiltInReports.pas',
  ucwClasses in 'ucwClasses.pas',
  ucwClassParser in 'ucwClassParser.pas',
  ucwClassTypesReport in 'ucwClassTypesReport.pas',
  ucwCodeMetricsReport in 'ucwCodeMetricsReport.pas',
  ucwCodingConventions in 'ucwCodingConventions.pas',
  ucwColumn in 'ucwColumn.pas',
  ucwColumns in 'ucwColumns.pas',
  ucwComponentPrefix in 'ucwComponentPrefix.pas',
  ucwDocument in 'ucwDocument.pas',
  ucwFileSettings in 'ucwFileSettings.pas',
  ucwFind in 'ucwFind.pas',
  ucwGlobalVarsReport in 'ucwGlobalVarsReport.pas',
  ucwIndentationConventions in 'ucwIndentationConventions.pas',
  ucwIniOptions in 'ucwIniOptions.pas',
  ucwInterfaceParser in 'ucwInterfaceParser.pas',
  ucwMessage in 'ucwMessage.pas',
  ucwMessageList in 'ucwMessageList.pas',
  ucwNamingConventions in 'ucwNamingConventions.pas',
  ucwNet in 'ucwNet.pas',
  ucwObjectParser in 'ucwObjectParser.pas',
  ucwOptions in 'ucwOptions.pas',
  ucwPasLintReport in 'ucwPasLintReport.pas',
  ucwPathUtils in 'ucwPathUtils.pas',
  ucwPersistIntf in 'ucwPersistIntf.pas',
  ucwPrefixList in 'ucwPrefixList.pas',
  ucwPreprocessImpl in 'ucwPreprocessImpl.pas',
  ucwPreprocessIntf in 'ucwPreprocessIntf.pas',
  ucwPreprocessor in 'ucwPreprocessor.pas',
  ucwProgressImpl in 'ucwProgressImpl.pas',
  ucwProgressIntf in 'ucwProgressIntf.pas',
  ucwProject in 'ucwProject.pas',
  ucwQuickSort in 'ucwQuickSort.pas',
  ucwRefactorOptions in 'ucwRefactorOptions.pas',
  ucwRegExpr in 'ucwRegExpr.pas',
  ucwReport in 'ucwReport.pas',
  ucwReportData in 'ucwReportData.pas',
  ucwReports in 'ucwReports.pas',
  ucwReportView in 'ucwReportView.pas',
  ucwRoutineParser in 'ucwRoutineParser.pas',
  ucwSetting in 'ucwSetting.pas',
  ucwSettings in 'ucwSettings.pas',
  ucwSettingsCategory in 'ucwSettingsCategory.pas',
  ucwStringList in 'ucwStringList.pas',
  ucwStringLiteralsReport in 'ucwStringLiteralsReport.pas',
  ucwStringTreeEx in 'ucwStringTreeEx.pas',
  ucwStructuredTypeParser in 'ucwStructuredTypeParser.pas',
  ucwSystemSymbolsReport in 'ucwSystemSymbolsReport.pas',
  ucwTreeNode in 'ucwTreeNode.pas',
  ucwTypeParser in 'ucwTypeParser.pas',
  ucwUnitParser in 'ucwUnitParser.pas',
  ucwUsedUnitsReport in 'ucwUsedUnitsReport.pas',
  ucwVarParser in 'ucwVarParser.pas',
  ucwSystemOptions in 'ucwSystemOptions.pas';

{$R *.res}

begin
  //RegisterExpectedMemoryLeak(IdComponent.GStackCriticalSection);
  Application.Initialize;
  Application.Title := 'CodeWrench';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TFindForm, FindForm);
  Application.CreateForm(TSystemOptionsForm, SystemOptionsForm);
  Application.Run;
end.



