unit CodeWrenchSystem;

interface

const
  MaxLongint: Longint = 0;
  MaxInt = 0;

type
  PWideChar = ^WideChar;
  AnsiChar = Char;
  PAnsiChar = ^AnsiChar;

const
  True: Boolean = 1;
  False: Boolean = 0;

var
  Self: Pointer = nil; //TODO: handle like Result for functions

function TypeInfo(const TypeIdent): Pointer;

procedure VarClear(V: Variant);

function Odd(X: Longint): Boolean;

function SizeOf(const ABuffer): Integer;

procedure RunError(ACode: Integer);

procedure Exit;

procedure Continue;

procedure Break;

procedure Halt(Exitcode: Integer = 0);

procedure Include(var S{: set of T}; const I{:T});

procedure Exclude(var S{: set of T}; const I{:T});

function Assigned(const APointer): Boolean;

function High(const ABuffer): Integer;

function Low(const ABuffer): Integer;

function Ord(const ABuffer): Integer;

function Chr(X: Byte): Char;

procedure Inc(var Value; AInc: Integer = 1);

procedure Dec(var Value; ADec: Integer = 1);

procedure SetLength(var S; ANewLength: Integer);

function Length(const S): Integer;

procedure FillChar(var X; Count: Integer; Value: Byte);

procedure SetString(var S: string; Buffer: PChar; Len: Integer);

procedure Str(const X; var S);

procedure Val(const S; var V; var Code: Integer);

function Copy(const S; Index, Count: Integer): string;

procedure Insert(Source: string; var S: string; Index: Integer);

procedure Delete(var S: string; Index, Count: Integer);

function Concat(S1, S2{, ...Sn}: string): string;

function StringOfChar(Ch: Char; Count: Integer): string;

function Pos(Substr: string; S: string): Integer;

procedure New(var P: Pointer);

procedure Dispose(var P: Pointer);

procedure GetMem(var P: Pointer; Size: Integer);

procedure FreeMem(var P: Pointer; Size: Integer = 0);

procedure Finalize(var V; Count: Integer = 0);

procedure ReallocMem(var P: Pointer; Size: Integer);

function Round(X: Extended): Int64;

function Trunc(X: Extended): Int64;

function Frac(X: Extended): Extended;

function Int(X: Extended): Extended;

function Abs(const X: Integer): Integer;

function Sqrt(X: Extended): Extended;

function Exp(X: Real): Real;

function Ln(X: Real): Real;

function Sqr(X: Extended): Extended; overload;
function Sqr(X: Integer): Integer; overload;

function Random(Range: Integer = 1): Real;

function Pi: Extended;

function ArcTan(X: Extended): Extended;

procedure Assert(Expr: Boolean; const Msg: string = '');

function Lo(X: Integer): Byte;

function Hi(X: Integer): Byte;

procedure Close(var F);

procedure GetDir(D: Byte; var S: string);

function Succ(const X): Integer;

function Pred(const X): Integer;

function Sin(X: Extended): Extended;

function Cos(X: Extended): Extended;

function Ptr(Address: Integer): Pointer;

function Addr(const X): Pointer;

procedure Swap(const X);

procedure Append(var F: Text);

procedure BlockRead(var F: Text; var Buf; Count: Integer; AmtTransferred: Integer = 0);

procedure BlockWrite(var F: Text; var Buf; Count: Integer; AmtTransferred: Integer = 0);

function Eof(var F): Boolean;

procedure Erase(var F);

function FilePos(var F): Longint;

function FileSize(var F): Integer;

function IOResult: Integer;

procedure MkDir(const S: string);

procedure Rename(var F; Newname: string);

procedure Reset(var F: Text; RecSize: Integer = 0);

procedure Rewrite(var F: Text; Recsize: Word = 0);

procedure ReadLn(var F: Text);

procedure Read(var F: Text);

procedure RmDir(const S: string);

procedure Seek(var F; N: Longint);

procedure Truncate(var F);

procedure Write(const F);

procedure Writeln(const F);

procedure AssignFile(var F; FileName: string);

procedure CloseFile(var F);

procedure VarCast(V1, V2: Variant; AVarType: Integer);

var
  ErrOutput: Text;
  FileMode: Byte = 2;
  Input: Text;
  Output: Text;

implementation

end.
