program DefaultPropertyTest;

type
  TDataClass = class
    Data: Byte;
  end;

  TDefaultPropertyClass = class
  private
    function GetItem(Index: Integer): TDataClass;
    procedure SetItem(Index: Integer; const Value: TDataClass);
  public
    property Items[Index: Integer]: TDataClass read GetItem write SetItem; default;
  end;

  IDataInterface = interface
    function GetData: Byte;
    procedure SetData(const Value: Byte);
    property Data: Byte read GetData write SetData;
  end;

  IDefaultPropertyInterface = interface
    function GetItem(Index: Integer): IDataInterface;
    procedure SetItem(Index: Integer; const Value: IDataInterface);
    property Items[Index: Integer]: IDataInterface read GetItem write SetItem; default;
  end;

  IDescendantInterface = interface(IDefaultPropertyInterface)
  end;

{ TDefaultPropertyClass }

function TDefaultPropertyClass.GetItem(Index: Integer): TDataClass;
begin
  Result := nil;
end;

procedure TDefaultPropertyClass.SetItem(Index: Integer; const Value: TDataClass);
begin
end;

var
  AClass: TDefaultPropertyClass;
  AInterface: IDefaultPropertyInterface;
  ADescendantInterface: IDescendantInterface;
begin
  AClass[0].Data := 0;
  AInterface[0].Data := 0;
  ADescendantInterface[0].Data := 0;
end.
 
