(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit frmcwMain;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Menus,
  ActnList,
  StdCtrls,
  Buttons,
  ComCtrls,
  ExtCtrls,
  ImgList,
  AppEvnts,
  StdActns,
  ToolWin,
  IniFiles,
  Contnrs,
  SynEditHighlighter,
  SynHighlighterPas,
  SynEdit,
  TB2Dock,
  TB2Item,
  TB2Toolbar,
  TB2MRU,
  frmcwBase,
  ucwTreeNode,
  ucwClasses,
  ucwDocument,
  frmcwFind;

type
  TMainForm = class(TFormBase, IcwCodeViewer, IcwProgressNotifier, IcwRefactoringHost)
    ofdOpenFile: TOpenDialog;
    ilTree: TImageList;
    SynPasSyntax: TSynPasSyn;
    ActionList: TActionList;
    actCut: TEditCut;
    actCopy: TEditCopy;
    actPaste: TEditPaste;
    actNew: TAction;
    actOpen: TAction;
    actOpenURL: TAction;
    actSave: TAction;
    actSaveAs: TAction;
    actExit: TAction;
    actAbout: TAction;
    ilActions: TImageList;
    ofdOpen: TOpenDialog;
    sfdSave: TSaveDialog;
    actRun: TAction;
    actOptions: TAction;
    stbMain: TStatusBar;
    actCancel: TAction;
    dckMenu: TTBDock;
    dckRight: TTBDock;
    dckLeft: TTBDock;
    tbMainMenu: TTBToolbar;
    mniFile: TTBSubmenuItem;
    mniFileNew: TTBItem;
    mniFileOpen: TTBItem;
    mniFileOpenURL: TTBItem;
    mniFileSave: TTBItem;
    mniFileSaveAs: TTBItem;
    mniFileExit: TTBItem;
    mniEdit: TTBSubmenuItem;
    mniEditCut: TTBItem;
    mniEditCopy: TTBItem;
    mniEditPaste: TTBItem;
    N2: TTBSeparatorItem;
    mniProject: TTBSubmenuItem;
    mniProjectRun: TTBItem;
    Cancel1: TTBItem;
    N3: TTBSeparatorItem;
    mniOptions: TTBItem;
    mniHelp: TTBSubmenuItem;
    mniHelpAbout: TTBItem;
    dckBottom: TTBDock;
    pnlMain: TPanel;
    pnlBottom: TPanel;
    pgcMessages: TPageControl;
    tabEditor: TTabSheet;
    seEditor: TSynEdit;
    tabMessages: TTabSheet;
    lvMessages: TListView;
    splBottom: TSplitter;
    pnlTop: TPanel;
    splTop: TSplitter;
    pnlTopLeft: TPanel;
    pagTopLeft: TPageControl;
    tabTree: TTabSheet;
    tvProjectTree: TTreeView;
    tabInheritance: TTabSheet;
    pnlTopRight: TPanel;
    pnlReportHeader: TPanel;
    pgcReports: TPageControl;
    dckTop: TTBDock;
    tbFileClipboard: TTBToolbar;
    tbiNew: TTBItem;
    tbiOpen: TTBItem;
    tbiSave: TTBItem;
    tbiCut: TTBItem;
    tbiCopy: TTBItem;
    tbiPaste: TTBItem;
    tbProject: TTBToolbar;
    tbiRun: TTBItem;
    tbiCancel: TTBItem;
    MRUListItem: TTBMRUListItem;
    MRUList: TTBMRUList;
    tbiMRUSeparator: TTBSeparatorItem;
    tvInheritance: TTreeView;
    pmEditor: TTBPopupMenu;
    TBItem1: TTBItem;
    TBItem2: TTBItem;
    TBItem3: TTBItem;
    actDelete: TAction;
    actSelectAll: TAction;
    TBItem4: TTBItem;
    TBItem5: TTBItem;
    TBSeparatorItem1: TTBSeparatorItem;
    actReadOnly: TAction;
    TBItem6: TTBItem;
    TBItem7: TTBItem;
    TBSeparatorItem2: TTBSeparatorItem;
    TBItem8: TTBItem;
    TBItem9: TTBItem;
    actEditSave: TAction;
    TBItem10: TTBItem;
    TBItem11: TTBItem;
    TBSeparatorItem3: TTBSeparatorItem;
    mniReports: TTBSubmenuItem;
    actCloseCurrentReport: TAction;
    TBItem12: TTBItem;
    TBSeparatorItem4: TTBSeparatorItem;
    Label1: TLabel;
    actCloseAllReports: TAction;
    TBItem13: TTBItem;
    actCodingConventions: TAction;
    TBItem14: TTBItem;
    ProjectPopupMenu: TPopupMenu;
    SearchFindAction: TAction;
    SearchFindNextAction: TAction;
    TBItem15: TTBItem;
    TBItem16: TTBItem;
    TBSeparatorItem5: TTBSeparatorItem;
    SystemOptionsAction: TAction;
    TBSeparatorItem6: TTBSeparatorItem;
    TBItem18: TTBItem;
    procedure actOptionsExecute(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure tvProjectTreeExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure lvMessagesDblClick(Sender: TObject);
    procedure tvProjectTreeDblClick(Sender: TObject);
    procedure tvProjectTreeCreateNodeClass(Sender: TCustomTreeView;
      var NodeClass: TTreeNodeClass);
    procedure actCancelExecute(Sender: TObject);
    procedure MRUListChange(Sender: TObject);
    procedure MRUListClick(Sender: TObject; const Filename: string);
    procedure dckMenuRequestDock(Sender: TObject;
      Bar: TTBCustomDockableWindow; var Accept: Boolean);
    procedure dckTopRequestDock(Sender: TObject;
      Bar: TTBCustomDockableWindow; var Accept: Boolean);
    procedure lvMessagesData(Sender: TObject; Item: TListItem);
    procedure seEditorStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure actReadOnlyExecute(Sender: TObject);
    procedure actCutExecute(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure actPasteExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actSelectAllExecute(Sender: TObject);
    procedure actSelectAllUpdate(Sender: TObject);
    procedure actDeleteUpdate(Sender: TObject);
    procedure actPasteUpdate(Sender: TObject);
    procedure actCopyUpdate(Sender: TObject);
    procedure actCutUpdate(Sender: TObject);
    procedure actEditSaveExecute(Sender: TObject);
    procedure actEditSaveUpdate(Sender: TObject);
    procedure actCloseCurrentReportExecute(Sender: TObject);
    procedure actCloseCurrentReportUpdate(Sender: TObject);
    procedure actCloseAllReportsExecute(Sender: TObject);
    procedure actCodingConventionsExecute(Sender: TObject);
    procedure actNewExecute(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actOpenURLExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actSaveAsExecute(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SearchFindActionExecute(Sender: TObject);
    procedure SearchFindNextActionExecute(Sender: TObject);
    procedure SearchFindNextActionUpdate(Sender: TObject);
    procedure SystemOptionsActionExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure lvMessagesColumnClick(Sender: TObject; Column: TListColumn);
  private
    FTickCount: Cardinal;
    FMessageList: TInterfaceList;
    FSymbolFound: Boolean;
    FDocument: TDocument;
    FLastEditorFile: string;
    FLastFileAge: Integer;
    FCancelParsing: Boolean;
    FRunning: boolean;
    FRefactoringList: TInterfaceList;

    procedure ShowEditorStatusBar;
    function HasEditFile: Boolean;

    procedure AddAvailableReports;
    procedure ShowMessages;
    procedure ShowCodeExplorer;
    procedure ShowInherianceTree;
    procedure ShowSourceFile(const aFileName: string; aX, aY: Integer);
    //if the notifier wants to cancel the parsing, it can set the Cancel flag
    procedure ShowProgress(const aFullFileName: string; ParseState:
      TParserState; var aCancelParsing: Boolean);
    procedure LoadVisibleReports;
    procedure ShowReport(const aReport: IcwReport);
    procedure OnSelectReport(Sender: TObject);
    procedure ShowAvailableReports;
    procedure CloseAllVisibleReports;
    procedure UpdateVisibleReports;
    procedure ShowReports;

    procedure AddToMRUList(const aFileName: string);

    procedure ClearUI;
    procedure UpdateUI(bLoadReports: boolean);

    function SavePrompt: word;
    function IsSaved(Sender: TObject): boolean;

    procedure NewDocument(const aFilename: string = '');
    procedure LoadDocument(const aFilename: string);
    procedure LoadDocumentFromURL(const aURL: string);
    procedure SaveDocument(const aFilename: string);

    procedure RenderDocument;
    procedure UpdateCaption;
    procedure Changed;

    procedure FindNextSymbol(AStartNode: TTreeNode = nil);
    procedure DoRefactoringActionUpdate(Sender: TObject);
    function GetActionRefactoring(AAction: TAction): IcwRefactoring;
    procedure DoRefactoringActionExecute(Sender: TObject);
    procedure InitMessageListViewItem(AItem: TListItem; const AMessage: IcwMessage);
    function GetGroupMenuItemName(AGroupName: string): string;
    function GetGroupMenuItem(AGroupName: string): TMenuItem;
  protected
    procedure UpdateActions; override;

    // property helpers
    procedure SetRunning(Value: boolean);

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property Running: Boolean read FRunning write SetRunning;

    function GetSelectedSymbol: TcwSymbol;
    property SelectedSymbol: TcwSymbol read GetSelectedSymbol;

    function GetSelectedUnit: TcwUnit;
    property SelectedUnit: TcwUnit read GetSelectedUnit;

    procedure RegisterRefactoring(const ARefactoring: IcwRefactoring; AGroupName: string = '');
    procedure UnregisterRefactoring(const ARefactoring: IcwRefactoring);

    procedure AcceptRefactoringMessage(const ARefactoring: IcwRefactoring;
      const AMessage: IcwMessage);

    procedure RefactoringStatus(const AUnit: TcwUnit);

    procedure AddGroupName(AGroupName: String; AGroupCaption: string;
      AParentGroupName: string = '');
    procedure RemoveGroupName(AGroupName: String);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
  ShellAPI,
  ucwProject,
  ucwReportView,
  frmcwOptions,
  frmcwCodeOptions,
  ucwStringList,
  ucwFileSettings,
  ucwBuiltInReports,
  ucwPersistIntf,
  ucwMessage,
  frmcwOpenURL,
  frmcwSystemOptions;

const
  SSAVEPROMPT = 'Do you want to save changes?';
  SMODIFIED = 'Modified';
  SUNTITLED = 'Untitled';
  SCOULDNOTSAVETOFILESPACE = 'Could not save to file ';
  SSPACEDDASH = ' - ';
  SSPACESTAR = ' *';
  SFULLPRODUCTNAME = 'CodeWrench';
  SPRODUCTNAME = 'CodeWrench';

constructor TMainForm.Create(AOwner: TComponent);
var
  Index: Integer;
  aFilename: string;
  Ini: TIniFile;
  sLastFileOpened: string;
  ApplicationName: string;
begin
  gcwRefactoringHost := Self as IcwRefactoringHost;
  ApplicationName := ParamStr(0);
  gcwCodeWrenchOptions := TcwFileSettings.Create(ChangeFileExt(ApplicationName, '.ini'));

  inherited;

  FRefactoringList := TInterfaceList.Create;
  FMessageList := TInterfaceList.Create;

  gcwProject := TcwProject.Create;
  gcwProject.AddCodeViewer(Self);
  gcwProject.AddProgressNotifier(Self);

  FDocument := TDocument.Create(gcwProject as IclPersist);

  Ini := TIniFile.Create(gcwCodeWrenchOptions.FileName);
  try
    MRUList.LoadFromIni(ini, 'Recent files');
  finally
    Ini.Free;
  end;

  // load parameter or new document
  if (ParamCount = 0) then
    NewDocument
  else
  begin
    aFilename := ExpandUNCFileName(ParamStr(1));
    if FileExists(aFilename) then
    begin
      try
        LoadDocument(aFilename);
      except
        on EFOpenError do
          {nothing};
      end;
    end else
      NewDocument(aFilename);
  end;

  ShowEditorStatusBar;

  if ParamStr(1) <> '-noplugins' then
    // load plugins
    for Index := 0 to gcwProject.SystemOptions.RefactorOptions.Refactorings.Count - 1 do
      try
        if gcwProject.SystemOptions.RefactorOptions.Refactorings[Index] <> '' then
          LoadPackage(gcwProject.SystemOptions.RefactorOptions.Refactorings[Index]);
      except
        on E: Exception do
          Application.ShowException(E);
      end;

  pnlTopLeft.Width := gcwCodeWrenchOptions.GetOption('MainForm', 'ExplorerWidth',
    pnlTopLeft.Width);
  pnlBottom.Height := gcwCodeWrenchOptions.GetOption('MainForm', 'BottomPanelHeight',
    pnlBottom.Height);
  seEditor.ReadOnly := gcwCodeWrenchOptions.GetOption('Editor', 'ReadOnly',
    seEditor.ReadOnly);
  actReadOnly.Checked := seEditor.ReadOnly;

  //pnlBottom.Height := gcwCodeWrenchOptions.GetOption('MainForm','messagesHeight',pnlBottom.Height);

  AddAvailableReports;
  ShowAvailableReports;

  if ((FDocument.FileName = '') and (MRUList.Items.Count > 0)) then
  begin
    sLastFileOpened := MRUList.Items[0];
    if FileExists(sLastFileOpened) then
      LoadDocument(sLastFileOpened);
  end;
end;

destructor TMainForm.Destroy;

  procedure DoDetach(const AProject: IcwProject);
  begin
    FDocument.Free;
    gcwProject.RemoveCodeViewer(Self);
    gcwProject.RemoveProgressNotifier(Self);
  end;

var
  Ini: TIniFile;
begin
  FRefactoringList.Free;
  FMessageList.Free;
  Ini := TIniFile.Create(gcwCodeWrenchOptions.FileName);
  try
    MRUList.SaveToIni(Ini, 'Recent files');
  finally
    Ini.Free;
  end;

  gcwCodeWrenchOptions.SetOption('MainForm', 'ExplorerWidth', pnlTopLeft.Width);
  gcwCodeWrenchOptions.SetOption('Editor', 'ReadOnly', seEditor.ReadOnly);
  gcwCodeWrenchOptions.SetOption('MainForm', 'BottomPanelHeight',
    pnlBottom.Height);

  CloseAllVisibleReports;

  DoDetach(gcwProject);
  gcwProject := nil;
  inherited;
  //after inherited, since the base forms write size to ini-file
  gcwCodeWrenchOptions := nil;
end;

procedure TMainForm.AddAvailableReports;
begin
  AddBuiltInReports;
end;

procedure TMainForm.CloseAllVisibleReports;
begin
  while pgcReports.PageCount > 0 do
  begin
    TVTReportViewer(pgcReports.ActivePage.Tag).Free;
    pgcReports.ActivePage.Free;
  end;
end;

procedure TMainForm.LoadVisibleReports;
var
  VisibleReports: IcwStringList;
  vReport: IcwReport;
  i: Integer;
begin
  //save the visible reports for this project
  VisibleReports := TcwStringList.Create;
  gcwProject.ProjectOptions.ReadSection('VisibleReports', VisibleReports);
  CloseAllVisibleReports;
  for i := 0 to VisibleReports.Count - 1 do
  begin
    vReport := gcwProject.Reports.GetReportByName(VisibleReports[i]);
    if vReport <> nil then
      ShowReport(vReport);
  end;
  UpdateVisibleReports;
end;

procedure TMainForm.actOptionsExecute(Sender: TObject);
begin
  if TfrmOptions.Execute then
    Changed;
end;

procedure TMainForm.ShowMessages;
begin
  FMessageList.Clear;
  lvMessages.OwnerData := True;
  lvMessages.Items.Count := gcwProject.Messages.Count;
end;

procedure TMainForm.ShowCodeExplorer;
var
  Node: TcwTreeNode;
  i: Integer;
  nUnit: TcwUnit;
begin
  tvProjectTree.Items.BeginUpdate;
  try
    tvProjectTree.Items.Clear;
    for i := 0 to gcwProject.ProjectUnit.UsedUnits.Count - 1 do
    begin
      nUnit := gcwProject.ProjectUnit.UsedUnits[i].UnitIntf;

      Node := TcwTreeNode(tvProjectTree.Items.AddObject(nil, nUnit.Name,
        Pointer(nUnit)));
      Node.UnitIntf := nUnit;
      Node.SymbolIntf := nil;
      Node.NodeType := stUnit;

      Node.HasChildren := ((nUnit.UsedUnits.Count > 0) or (nUnit.UsedBy.Count >
        0) or
        (nUnit.Classes.Count > 0) or (nUnit.Routines.Count > 0) or
        (nUnit.Variables.Count > 0) or (nUnit.Interfaces.Count > 0) or
        (nUnit.Objects.Count > 0) or (nUnit.Records.Count > 0) or
        (nUnit.Constants.Count > 0));

      Node.ImageIndex := 0;
      Node.SelectedIndex := 0;
    end;
  finally
    tvProjectTree.Items.EndUpdate;
  end;
end;

procedure TMainForm.ShowInherianceTree;
var
  AUnitNode: TcwTreeNode;
  Index: Integer;
  Node: TcwTreeNode;
  i, j: Integer;
  nUnit: TcwUnit;
  bHasClasses: Boolean;
  bHasObjects: Boolean;
  bHasInterfaces: Boolean;
begin
  tvInheritance.Items.BeginUpdate;
  try
    tvInheritance.Items.Clear;
    bHasClasses := False;
    for i := 0 to gcwProject.AllUnits.Count - 1 do
    begin
      nUnit := gcwProject.AllUnits[i];
      for j := 0 to nUnit.Classes.Count - 1 do
      begin
        if nUnit.Classes[j].InheritsFromClass = nil then
        begin
          bHasClasses := TRUE;
          BREAK;
        end;
      end;
      if bHasClasses then
        BREAK;
    end;
    if not bHasClasses then
      for j := 0 to gcwProject.UnparsedClasses.Count - 1 do
      begin
        if gcwProject.UnparsedClasses[j].InheritsFromClass = nil then
        begin
          bHasClasses := TRUE;
          BREAK;
        end;
      end;

    bHasObjects := False;
    for i := 0 to gcwProject.AllUnits.Count - 1 do
    begin
      nUnit := gcwProject.AllUnits[i];
      for j := 0 to nUnit.Objects.Count - 1 do
      begin
        if nUnit.Objects[j].InheritsFromClass = nil then
        begin
          bHasObjects := TRUE;
          BREAK;
        end;
      end;
      if bHasObjects then
        BREAK;
    end;
    if not bHasObjects then
      for j := 0 to gcwProject.UnparsedObjects.Count - 1 do
      begin
        if gcwProject.UnparsedObjects[j].InheritsFromClass = nil then
        begin
          bHasObjects := TRUE;
          BREAK;
        end;
      end;

    bHasInterfaces := False;
    for i := 0 to gcwProject.AllUnits.Count - 1 do
    begin
      nUnit := gcwProject.AllUnits[i];
      for j := 0 to nUnit.Interfaces.Count - 1 do
      begin
        if nUnit.Interfaces[j].Interfaces.Count = 0 then
        begin
          bHasInterfaces := TRUE;
          BREAK;
        end;
      end;
      if bHasInterfaces then
        BREAK;
    end;
    if not bHasInterfaces then
      for j := 0 to gcwProject.UnparsedInterfaces.Count - 1 do
      begin
        if gcwProject.UnparsedInterfaces[j].Interfaces.Count = 0 then
        begin
          bHasInterfaces := TRUE;
          BREAK;
        end;
      end;

    if bHasClasses then
    begin
      Node := TcwTreeNode(tvInheritance.Items.AddChild(nil, 'Classes'));
      Node.NodeType := stClasses;
      Node.HasChildren := True;
      Node.ImageIndex := ImageIndexes[stClasses];
      Node.SelectedIndex := ImageIndexes[stClasses];
    end;

    if bHasObjects then
    begin
      Node := TcwTreeNode(tvInheritance.Items.AddChild(nil, 'Objects'));
      Node.NodeType := stObjects;
      Node.HasChildren := True;
      Node.ImageIndex := ImageIndexes[stObjects];
      Node.SelectedIndex := ImageIndexes[stObjects];
    end;

    if bHasInterfaces then
    begin
      Node := TcwTreeNode(tvInheritance.Items.AddChild(nil, 'Interfaces'));
      Node.NodeType := stInterfaces;
      Node.HasChildren := True;
      Node.ImageIndex := ImageIndexes[stInterfaces];
      Node.SelectedIndex := ImageIndexes[stInterfaces];
    end;

    Node := TcwTreeNode(tvInheritance.Items.AddChild(nil, 'Units'));
    Node.NodeType := stUnit;
    Node.HasChildren := True;
    Node.ImageIndex := ImageIndexes[stUnit];
    Node.SelectedIndex := ImageIndexes[stUnit];
    for Index := 0 to gcwProject.AllUnits.Count - 1 do
    begin
      AUnitNode := Node.AddUnit(Node, gcwProject.AllUnits.SortedUnits[Index]);
      AUnitNode.ExpandNode(True);
    end;
  finally
    tvInheritance.Items.EndUpdate;
  end;
end;

//if the notifier wants to cancel the parsing, it can set the Cancel flag

procedure TMainForm.ShowProgress(const aFullFileName: string; ParseState:
  TParserState; var aCancelParsing: Boolean);
const
  asPARSERSTATES: array[TParserState] of string = ('', 'Interface', '',
    'Implementation');
begin
  if GetTickCount - FTickCount > 300 then
  begin
    stbMain.Panels[4].Text := aFullFileName + ' ' + asPARSERSTATES[ParseState];
    stbMain.Update;
    Application.ProcessMessages;
    aCancelParsing := FCancelParsing;
    FTickCount := GetTickCount;
  end;
end;

function TMainForm.HasEditFile: Boolean;
begin
  Result := Length(FLastEditorFile) <> 0;
end;

procedure TMainForm.ShowSourceFile(const aFileName: string; aX, aY: Integer);
begin
  if (aX = 0) or (aY = 0) then
    EXIT;
  if FileExists(aFileName) then
  begin
    pgcMessages.ActivePage := tabEditor;
    if (FLastEditorFile <> aFileName) or
      (FLastFileAge <> FileAge(aFileName)) then
    begin
      FLastFileAge := FileAge(aFileName);
      seEditor.Lines.LoadFromFile(aFileName);
    end;
    ShowEditorStatusBar;
    FLastEditorFile := aFileName;
    seEditor.CaretX := aX;
    seEditor.CaretY := aY;
    seEditor.EnsureCursorPosVisible;
    seEditor.Setfocus;
  end;
end;

procedure TMainForm.OnSelectReport(Sender: TObject);
var
  vReport: IcwReport;
begin
  vReport := IcwReport((Sender as TTBItem).Tag);
  vReport.Execute;
  ShowReport(vReport);
  UpdateVisibleReports;

  Changed;
end;

procedure TMainForm.ShowAvailableReports;
var
  i: Integer;
  vReport: IcwReport;
  mnuItem: TTBItem;
begin
  for i := 0 to gcwProject.Reports.Count - 1 do
  begin
    vReport := gcwProject.Reports[i];
    mnuItem := TTBItem.Create(mniReports);
    mnuItem.Caption := vReport.Name;
    mnuItem.Tag := Integer(vReport);
    mnuItem.OnClick := OnSelectReport;
    mniReports.Add(mnuItem);
  end;
end;

procedure TMainForm.UpdateVisibleReports;
var
  i, j: Integer;
  vReport: IcwReport;
  bFound: Boolean;
begin
  for i := 0 to mniReports.Count - 1 do
  begin
    if mniReports.Items[i].Tag <> 0 then
    begin
      vReport := IcwReport(mniReports.Items[i].Tag);
      bFound := False;
      for j := 0 to pgcReports.PageCount - 1 do
      begin
        if TVTReportViewer(pgcReports.Pages[j].Tag).Report = vReport then
        begin
          bFound := true;
          BREAK;
        end;
      end;
      mniReports.Items[i].Checked := bFound;
    end;
  end;
end;

procedure TMainForm.ShowReports;
var
  i: integer;
  vtReportViewer: TVTReportViewer;
  tbs: TTabSheet;
begin
  for i := 0 to pgcReports.PageCount - 1 do
  begin
    vtReportViewer := TVTReportViewer(pgcReports.Pages[i].Tag);
    tbs := pgcReports.Pages[i];
    vtReportViewer.Report.Execute;
    vtReportViewer.UpdateReportVirtualTreeView(tbs, vtReportViewer.Report);
  end;
end;

procedure TMainForm.AddToMRUList(const aFileName: string);
var
  iIndex: integer;
begin
  if (aFileName <> '') then
  begin
    // delete from existing list
    repeat
      iIndex := MRUList.Items.IndexOf(aFileName);
      if (iIndex >= 0) then
        MRUList.Items.Delete(iIndex);

    until (iIndex < 0);

    // add in top spot
    MRUList.Items.Insert(0, aFileName);
  end;
end;

procedure TMainForm.ClearUI;
begin
  gcwProject.Clear;
  UpdateUI(True)
end;

procedure TMainForm.UpdateUI(bLoadReports: boolean);
begin
  if bLoadReports then
    LoadVisibleReports;

  ShowMessages;
  ShowCodeExplorer;
  ShowInherianceTree;
  ShowReports;
  ShowEditorStatusBar;
end;

function TMainForm.SavePrompt: word;
begin
  Result := MessageDlg(SSAVEPROMPT, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
end;

function TMainForm.IsSaved(Sender: TObject): boolean;
var
  wResult: word;
begin
  // init result
  Result := not FDocument.IsDirty;

  if FDocument.IsDirty then
  begin
    // prompt to save
    wResult := SavePrompt;

    // exit on Cancel
    if (wResult = mrCancel) then
      Exit;

    // save on Yes
    if (wResult = mrYes) then
      actSaveExecute(Sender);

    Result := TRUE;
  end;
end;

procedure TMainForm.NewDocument(const aFilename: string = '');
var
  vFileName: string;
begin
  // work around bug in Dream Inspector
  ClearUI;
  vFileName := aFilename;
  // new document
  FDocument.New;

  (*if gcwProject.CWOptions.FileToAnalyze = '' then
  begin
    ofdOpenFile.FileName := '';
    if ofdOpenFile.Execute then
    begin
      gcwProject.CWOptions.FileToAnalyze := ofdOpenFile.FileName;
      FDocument.IsDirty := TRUE;
    end;
  end;
  *)

  // maybe set filename & dirty flag
  if (vFileName <> '') then
  begin
    FDocument.FileName := vFileName;
    FDocument.IsDirty := TRUE;
  end;

  // render document
  RenderDocument;

  // update visuals
  UpdateCaption;
  UpdateUI(True)
end;

procedure TMainForm.LoadDocument(const aFilename: string);
begin
  ClearUI;

  // load document
  FDocument.FileName := aFilename;
  if not FDocument.Load then
    EXIT;
  AddToMRUList(FDocument.FileName);

  // render document
  RenderDocument;

  // update visuals
  UpdateCaption;
  UpdateUI(True)
end;

procedure TMainForm.LoadDocumentFromURL(const aURL: string);
begin
  ClearUI;

  // load document
  FDocument.FileName := aURL;
  FDocument.Download(aURL);
  AddToMRUList(FDocument.FileName);

  // render document
  RenderDocument;

  // update visuals
  UpdateCaption;
  UpdateUI(True)
end;

procedure TMainForm.SaveDocument(const aFilename: string);
begin
  // save document
  FDocument.FileName := aFilename;
  FDocument.Save;
  AddToMRUList(FDocument.FileName);

  // update visuals
  UpdateCaption;
  UpdateUI(True)
end;

procedure TMainForm.RenderDocument;
begin
  UpdateCaption;
  UpdateUI(True)
end;

procedure TMainForm.UpdateActions;
begin
  inherited;

  actSave.Enabled := (FDocument.CanSave and (FDocument.IsDirty or
    (FDocument.FileName = '')));

  if FDocument.IsDirty then
    UpdateCaption;
end;

procedure TMainForm.UpdateCaption;
var
  sCaption, sDirty: string;
begin
  if (FDocument.FileName = '') then
    // unnamed files
    sCaption := SUNTITLED
  else if FileExists(FDocument.FileName) then
    // normal files
    sCaption := ExtractFileName(FDocument.FileName)
  else
    // URLs
    sCaption := FDocument.FileName;

  if FDocument.IsDirty then
    sDirty := SSPACESTAR
  else
    sDirty := '';

  Caption := sCaption + SSPACEDDASH + SFULLPRODUCTNAME + sDirty;
  Application.Title := sCaption + SSPACEDDASH + SPRODUCTNAME;
end;

procedure TMainForm.Changed;
begin
  FDocument.IsDirty := TRUE;
end;

procedure TMainForm.SetRunning(Value: boolean);
begin
  if (Value <> FRunning) then
  begin
    FRunning := Value;
    actCancel.Enabled := FRunning;
    actRun.Enabled := not FRunning;
  end;
end;

procedure TMainForm.Run1Click(Sender: TObject);
var
  ATickCount: Cardinal;
begin
  ATickCount := GetTickCount;
  Screen.Cursor := crHourGlass;
  try
    Running := TRUE;
    try
      FCancelParsing := FALSE;
      gcwProject.Run;

      if FCancelParsing then
        ShowProgress('Parsing canceled', psrNone, FCancelParsing)
      else
        ShowProgress('', psrNone, FCancelParsing);

      UpdateVisibleReports;
      UpdateUI(False);

    finally
      Running := FALSE;
    end;

  finally
    Screen.Cursor := crDefault;
  end;
  stbMain.Panels[stbMain.Panels.Count - 1].Text := Format('%f (s)',
    [(GetTickCount - ATickCount) / 1000]);
end;

procedure TMainForm.tvProjectTreeExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
  if (Node.Count = 0) then
    TcwTreeNode(Node).ExpandNode(Sender = tvProjectTree);
end;

procedure TMainForm.lvMessagesDblClick(Sender: TObject);
var
  Item: TListItem;
  cwMessage: IcwMessage;
begin
  inherited;
  Item := lvMessages.Selected;
  if Item <> nil then
  begin
    cwMessage := FMessageList[Integer(Item.Data)] as IcwMessage; //gcwProject.Messages[Item.Index];
    ShowSourceFile(Item.SubItems[0], cwMessage.CodeLocation.X, cwMessage.CodeLocation.Y);
  end;
end;

procedure TMainForm.tvProjectTreeDblClick(Sender: TObject);
var
  Node: TcwTreeNode;
begin
  inherited;
  Node := TcwTreeNode((Sender as TTreeView).Selected);
  if Node <> nil then
    Node.Execute;
end;

procedure TMainForm.tvProjectTreeCreateNodeClass(Sender: TCustomTreeView; var
  NodeClass: TTreeNodeClass);
begin
  NodeClass := TcwTreeNode;
end;

procedure TMainForm.ShowReport(const aReport: IcwReport);
var
  tbs: TTabSheet;
  i: Integer;
  vtReportViewer: TVTReportViewer;
begin
  tbs := nil;
  vtReportViewer := nil;
  //find if the report has already been created
  for i := 0 to pgcReports.PageCount - 1 do
  begin
    if (TVTReportViewer(pgcReports.Pages[i].Tag).Report = aReport) then
    begin
      vtReportViewer := TVTReportViewer(pgcReports.Pages[i].Tag);
      tbs := pgcReports.Pages[i];
      BREAK;
    end;
  end;
  if tbs = nil then
  begin
    tbs := TTabSheet.Create(pgcReports);
    tbs.PageControl := pgcReports;
    tbs.Caption := aReport.Name;
    vtReportViewer := TVTReportViewer.Create;
    vtReportViewer.CreateReportVirtualTreeView(tbs, aReport);
    tbs.Tag := integer(vtReportViewer);
  end;
  pgcReports.ActivePage := tbs;
  vtReportViewer.UpdateReportVirtualTreeView(tbs, aReport);

  aReport.Visible := TRUE;
end;

procedure TMainForm.actCancelExecute(Sender: TObject);
begin
  FCancelParsing := TRUE;
end;

procedure TMainForm.MRUListChange(Sender: TObject);
begin
  inherited;
  tbiMRUSeparator.Visible := (MRUList.Items.Count > 0);
end;

procedure TMainForm.MRUListClick(Sender: TObject; const Filename: string);
begin
  inherited;

  // save current document
  if not IsSaved(Sender) then
    Exit;

  // open document from file
  LoadDocument(Filename);
end;

procedure TMainForm.dckMenuRequestDock(Sender: TObject;
  Bar: TTBCustomDockableWindow; var Accept: Boolean);
begin
  inherited;
  Accept := (Bar = tbMainMenu);
end;

procedure TMainForm.dckTopRequestDock(Sender: TObject;
  Bar: TTBCustomDockableWindow; var Accept: Boolean);
begin
  inherited;
  Accept := (Bar <> tbMainMenu);
end;

procedure TMainForm.InitMessageListViewItem(AItem: TListItem; const AMessage: IcwMessage);
begin
  AItem.Caption := AMessage.MessageText;
  AItem.SubItems.Add(AMessage.CodeLocation.FileName);
  AItem.SubItems.Add(Format('%d,%d', [AMessage.CodeLocation.X, AMessage.CodeLocation.Y]));
  AItem.SubItems.Add(BoolToStr(AMessage.InterfaceSection, True));
  AItem.Data := Pointer(FMessageList.Add(AMessage));
end;

procedure TMainForm.AcceptRefactoringMessage(const ARefactoring: IcwRefactoring;
  const AMessage: IcwMessage);
var
  AModifiedMessage: IcwMessage;
begin
  lvMessages.OwnerData := False;
  AModifiedMessage := TcwMessage.Create(Format('%s: %s', [ARefactoring.Name, AMessage.MessageText]),
    AMessage.CodeLocation.FileIndex, AMessage.CodeLocation.X, AMessage.CodeLocation.Y, False);
  InitMessageListViewItem(lvMessages.Items.Add, AModifiedMessage);
end;

procedure TMainForm.lvMessagesData(Sender: TObject; Item: TListItem);
begin
  if (Item.Index >= gcwProject.Messages.Count) then
    Exit;
  InitMessageListViewItem(Item, gcwProject.Messages[Item.Index]);
end;

procedure TMainForm.ShowEditorStatusBar;
begin
  stbMain.panels[0].Text := Format('%6d:%3d', [seEditor.CaretY,
    seEditor.CaretX]);
  if seEditor.InsertMode then
    stbMain.panels[1].Text := 'Insert'
  else
    stbMain.panels[1].Text := 'Overwrite';
  if seEditor.Modified then
    stbMain.panels[2].Text := 'Modified'
  else
    stbMain.panels[2].Text := '';
  if seEditor.ReadOnly then
    stbMain.panels[3].Text := 'Read-Only'
  else
    stbMain.panels[3].Text := '';
  stbMain.panels[4].Text := FLastEditorFile;
end;

procedure TMainForm.seEditorStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  if Changes * [scCaretX, scCaretY, scInsertMode, scModified, scReadOnly] <> []
    then
  begin
    ShowEditorStatusBar;
  end;
end;

procedure TMainForm.actReadOnlyExecute(Sender: TObject);
begin
  inherited;
  seEditor.ReadOnly := actReadOnly.Checked;
end;

procedure TMainForm.actCutExecute(Sender: TObject);
begin
  seEditor.CutToClipboard;
end;

procedure TMainForm.actCopyExecute(Sender: TObject);
begin
  seEditor.CopyToClipboard;
end;

procedure TMainForm.actPasteExecute(Sender: TObject);
begin
  seEditor.PasteFromClipboard;
end;

procedure TMainForm.actDeleteExecute(Sender: TObject);
begin
  seEditor.SelText := '';
end;

procedure TMainForm.actSelectAllExecute(Sender: TObject);
begin
  seEditor.SelectAll;
end;

procedure TMainForm.actSelectAllUpdate(Sender: TObject);
begin
  actSelectAll.Enabled := HasEditFile;
end;

procedure TMainForm.actDeleteUpdate(Sender: TObject);
begin
  actDelete.Enabled := seEditor.SelAvail and not seEditor.ReadOnly;
end;

procedure TMainForm.actPasteUpdate(Sender: TObject);
begin
  actPaste.Enabled := seEditor.CanPaste and not seEditor.ReadOnly;
end;

procedure TMainForm.actCopyUpdate(Sender: TObject);
begin
  actCopy.Enabled := seEditor.SelAvail;
end;

procedure TMainForm.actCutUpdate(Sender: TObject);
begin
  actCut.Enabled := seEditor.SelAvail and not seEditor.ReadOnly;
end;

procedure TMainForm.actEditSaveExecute(Sender: TObject);
begin
  seEditor.Lines.SaveToFile(FLastEditorFile);
  seEditor.Modified := FALSE;
end;

procedure TMainForm.actEditSaveUpdate(Sender: TObject);
begin
  actEditSave.Enabled := HasEditFile and not seEditor.ReadOnly;
end;

procedure TMainForm.actCloseCurrentReportExecute(Sender: TObject);
begin
  if pgcReports.PageCount > 0 then
  begin
    TVTReportViewer(pgcReports.ActivePage.Tag).Free;
    pgcReports.ActivePage.Free;
    UpdateVisibleReports;
  end;
end;

procedure TMainForm.actCloseCurrentReportUpdate(Sender: TObject);
begin
  actCloseCurrentReport.Enabled := (pgcReports.PageCount > 0) and
    (pgcReports.ActivePage <> nil);
end;

procedure TMainForm.actCloseAllReportsExecute(Sender: TObject);
begin
  CloseAllVisibleReports;
end;

procedure TMainForm.actCodingConventionsExecute(Sender: TObject);
begin
  ShowCodingConventions(gcwProject.CodingConventions);
end;

procedure TMainForm.actNewExecute(Sender: TObject);
begin
  inherited;

  // sanity check
  if ((FDocument.FileName = '') and not FDocument.IsDirty) then
    Exit;

  // save current document
  if not IsSaved(Sender) then
    Exit;

  // load new document
  NewDocument;
end;

procedure TMainForm.actOpenExecute(Sender: TObject);
begin
  inherited;

  if ofdOpen.Execute then
  begin
    // save current document
    if not IsSaved(Sender) then
      Exit;

    // open document from file
    LoadDocument(ofdOpen.FileName);
  end;
end;

procedure TMainForm.actOpenURLExecute(Sender: TObject);
var
  aURL: string;
begin
  inherited;

  aURL := EditURL(MRUList.Items);
  if (aURL <> '') then
  begin
    // save current document
    if not IsSaved(Sender) then
      Exit;

    // open document from URL
    LoadDocumentFromURL(aURL);
  end;
end;

procedure TMainForm.actSaveExecute(Sender: TObject);
begin
  inherited;

  // save current document
  if (FDocument.FileName = '') then
    actSaveAsExecute(Sender)
  else
    SaveDocument(FDocument.FileName);
end;

procedure TMainForm.actSaveAsExecute(Sender: TObject);
begin
  inherited;

  // save current document with new filename
  if sfdSave.Execute then
    SaveDocument(sfdSave.FileName);
end;

procedure TMainForm.actExitExecute(Sender: TObject);
begin
  inherited;
  Close;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  // save current document
  if not IsSaved(Sender) then
    Action := caNone;
end;

procedure TMainForm.FindNextSymbol(AStartNode: TTreeNode = nil);

  function FindNextSymbolInTreeNode(const ATreeNode: TTreeNode; const
    ASearchNode: Boolean; var ANodeFound: Boolean; ASearchedProjectUnits: Boolean): Boolean;
  var
    AWasExpanded: Boolean;
    Index: Integer;
  begin
    if not ANodeFound then
      ANodeFound := AStartNode = ATreeNode;
    Result := ASearchNode and
      not (TcwTreeNode(ATreeNode).NodeType in VirtualSymbolTreeNodes) and
      Assigned(TcwTreeNode(ATreeNode).SymbolIntf) and
      FindForm.Match(TcwTreeNode(ATreeNode).SymbolIntf.Name);
    if Result then
    begin
      tvProjectTree.Selected := ATreeNode;
      tvProjectTree.TopItem := tvProjectTree.Selected;
    end else
    begin
      if not (TcwTreeNode(ATreeNode).NodeType in [stUsedBy]) and
        ((TcwTreeNode(ATreeNode).NodeType <> stUsedUnits) or not ASearchedProjectUnits) then
      begin
        if TcwTreeNode(ATreeNode).NodeType = stUsedUnits then
          ASearchedProjectUnits := True;
        AWasExpanded := ATreeNode.Expanded;
        if ATreeNode.Count = 0 then
          TcwTreeNode(ATreeNode).ExpandNode(True);
        for Index := 0 to ATreeNode.Count - 1 do
        begin
          Result := FindNextSymbolInTreeNode(ATreeNode[Index],
            not Assigned(AStartNode) or ANodeFound, ANodeFound, ASearchedProjectUnits);
          if Result then
            Break;
        end;
        if not Result and not AWasExpanded then
          ATreeNode.Collapse(False);
      end;
    end;
  end;

var
  ANodeFound: Boolean;
begin
  Screen.Cursor := crHourGlass;
  tvProjectTree.Items.BeginUpdate;
  try
    ANodeFound := False;
    FSymbolFound := FindNextSymbolInTreeNode(tvProjectTree.Items[0], False,
      ANodeFound, False);
    if not FSymbolFound then
      ShowMessage('Finished search.');
  finally
    tvProjectTree.Items.EndUpdate;
    tvProjectTree.SetFocus;
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.SearchFindActionExecute(Sender: TObject);
begin
  if FindForm.ShowModal = mrOk then
    FindNextSymbol;
end;

procedure TMainForm.SearchFindNextActionExecute(Sender: TObject);
begin
  FindNextSymbol(tvProjectTree.Selected);
end;

procedure TMainForm.SearchFindNextActionUpdate(Sender: TObject);
begin
  SearchFindNextAction.Enabled := Assigned(tvProjectTree.Selected) and
    Assigned(tvProjectTree.Selected.Parent) and FSymbolFound;
end;

procedure TMainForm.SystemOptionsActionExecute(Sender: TObject);
begin
  SystemOptionsForm.ShowModal;
end;

function TMainForm.GetSelectedSymbol: TcwSymbol;
begin
  if Assigned(tvProjectTree.Selected) and not (TcwTreeNode(tvProjectTree.Selected).NodeType in
    VirtualSymbolTreeNodes) then
    Result := TcwTreeNode(tvProjectTree.Selected).SymbolIntf
  else
    Result := nil;
end;

function TMainForm.GetSelectedUnit: TcwUnit;
begin
  if Assigned(tvProjectTree.Selected) and not (TcwTreeNode(tvProjectTree.Selected).NodeType in
    VirtualSymbolTreeNodes) then
    Result := TcwTreeNode(tvProjectTree.Selected).UnitIntf
  else
    Result := nil;
end;

procedure TMainForm.RegisterRefactoring(const ARefactoring: IcwRefactoring;
  AGroupName: string = '');
var
  AMenuItem: TMenuItem;
  AParentMenuItem: TMenuItem;
  AAction: TAction;
begin
  FRefactoringList.Add(ARefactoring);
  AAction := TAction.Create(ActionList);
  AAction.Caption := ARefactoring.MenuCaption;
  AAction.OnExecute := DoRefactoringActionExecute;
  AAction.OnUpdate := DoRefactoringActionUpdate;
  AAction.Tag := FRefactoringList.Count - 1;

  if AGroupName = '' then
    AParentMenuItem := nil
  else
    AParentMenuItem := GetGroupMenuItem(AGroupName);

  AMenuItem := TMenuItem.Create(Self);
  AMenuItem.Action := AAction;
  AMenuItem.Tag := FRefactoringList.Count - 1;
  if Assigned(AParentMenuItem) then
    AParentMenuItem.Add(AMenuItem)
  else
    ProjectPopupMenu.Items.Add(AMenuItem);
end;

function TMainForm.GetActionRefactoring(AAction: TAction): IcwRefactoring;
begin
  Result := FRefactoringList[AAction.Tag] as IcwRefactoring;
end;

procedure TMainForm.DoRefactoringActionUpdate(Sender: TObject);
var
  AAction: TAction;
begin
  AAction := Sender as TAction;
  AAction.Enabled := GetActionRefactoring(AAction).CanExecute;
end;

procedure TMainForm.DoRefactoringActionExecute(Sender: TObject);
begin
  GetActionRefactoring(Sender as TAction).Execute;
end;

procedure TMainForm.UnregisterRefactoring(const ARefactoring: IcwRefactoring);
var
  AIndex: Integer;
begin
  AIndex := FRefactoringList.IndexOf(ARefactoring);
  if AIndex >= 0 then
  begin
    //TODO: remove menu item and action
    FRefactoringList.Delete(AIndex);
  end else
    raise Exception.Create('Refactoring not registered.');
end;

procedure TMainForm.RefactoringStatus(const AUnit: TcwUnit);
var
  ACancelParsing: Boolean;
begin
  ShowProgress(AUnit.FullFileName, psrNone, ACancelParsing);
end;

function TMainForm.GetGroupMenuItemName(AGroupName: string): string;
begin
  Result := Format('%sMenuItem', [AGroupName]);
end;

function TMainForm.GetGroupMenuItem(AGroupName: string): TMenuItem;
var
  AComponent: TComponent;
begin
  AComponent := FindComponent(GetGroupMenuItemName(AGroupName));
  if not Assigned(AComponent) then
    raise Exception.CreateFmt('Group, %s, not found', [AGroupName]);
  Assert(AComponent is TMenuItem);
  Result := AComponent as TMenuItem;
end;

procedure TMainForm.AddGroupName(AGroupName: String; AGroupCaption: string;
  AParentGroupName: string = '');
var
  AMenuItem: TMenuItem;
  AParentMenuItem: TMenuItem;
  AComponent: TComponent;
begin
  if AParentGroupName = '' then
    AParentMenuItem := nil
  else
    AParentMenuItem := GetGroupMenuItem(AParentGroupName);

  AComponent := FindComponent(GetGroupMenuItemName(AGroupName));
  if Assigned(AComponent) then
    raise Exception.CreateFmt('Group, %s, already added', [AGroupName]);

  AMenuItem := TMenuItem.Create(Self);
  AMenuItem.Name := GetGroupMenuItemName(AGroupName);
  AMenuItem.Caption := AGroupCaption;
  if Assigned(AParentMenuItem) then
    AParentMenuItem.Add(AMenuItem)
  else
    ProjectPopupMenu.Items.Add(AMenuItem);
end;

procedure TMainForm.RemoveGroupName(AGroupName: String);
begin
  GetGroupMenuItem(AGroupName).Free;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  inherited;
  if MRUList.Items.Count > 0 then
    MRUList.OnClick(MRUList, MRUList.Items[MRUList.Items.Count - 1]);
end;

procedure TMainForm.lvMessagesColumnClick(Sender: TObject; Column: TListColumn);
begin
  inherited;
  case Column.Index of
    0: gcwProject.Messages.Sort(mlsbMessage);
    1: gcwProject.Messages.Sort(mlsbUnit);
    2: ;
    3: gcwProject.Messages.Sort(mlsbInterface);
    else
      Assert(False);
  end;
  lvMessages.Refresh;
end;

end.

