(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit frmcwPrefixDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frmcwBaseDialog, frmcwBase, StdCtrls, ExtCtrls;

type
  TPrefixDlg = class(TBaseDialogForm)
    edtPrefix: TEdit;
    edtComponentClass: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure ButtonOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function GetComponentPrefix(var aPrefix, aComponentClass : string) : boolean;
implementation

{$R *.dfm}

function GetComponentPrefix(var aPrefix, aComponentClass : string) : boolean;
var vPrefixDlg : TPrefixDlg;
begin
  vPrefixDlg := TPrefixDlg.Create(nil);
  try
    vPrefixDlg.edtPrefix.Text := aPrefix;
    vPrefixDlg.edtComponentClass.Text := aComponentClass;
    Result := vPrefixDlg.ShowModal = mrOK;
    if Result then
    begin
      aPrefix := vPrefixDlg.edtPrefix.Text;
      aComponentClass := vPrefixDlg.edtComponentClass.Text;
    end;
  finally
    vPrefixDlg.Release;
  end;
end;

procedure TPrefixDlg.ButtonOKClick(Sender: TObject);
begin
  Modalresult := mrNone;
  if Trim(edtPrefix.Text) = '' then
  begin
    ShowMessage('Please enter a prefix');
    edtPrefix.SetFocus;
    EXIT;
  end;

  if Trim(edtComponentClass.Text) = '' then
  begin
    ShowMessage('Please enter a Component Class');
    edtComponentClass.SetFocus;
    EXIT;
  end;

  Modalresult := mrOK;
end;

end.
