(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit frmcwSystemOptions;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  ExtCtrls,
  frmcwBaseDialog,
  frmcwBase;

type
  TSystemOptionsForm = class(TBaseDialogForm)
    PageControl1: TPageControl;
    RefactoringTabSheet: TTabSheet;
    ApplicationEdit: TEdit;
    Label1: TLabel;
    BrowseApplicationButton: TButton;
    ParamsEdit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ApplicationOpenDialog: TOpenDialog;
    Label4: TLabel;
    RefactoringsMemo: TMemo;
    BrowseRefactoringButton: TButton;
    OpenRefactoringDialog: TOpenDialog;
    Label5: TLabel;
    procedure BrowseApplicationButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BrowseRefactoringButtonClick(Sender: TObject);
  private
  public
  end;

var
  SystemOptionsForm: TSystemOptionsForm;

implementation

{$R *.dfm}

uses
  ucwClasses;

procedure TSystemOptionsForm.BrowseApplicationButtonClick(Sender: TObject);
begin
  if ApplicationOpenDialog.Execute then
    ApplicationEdit.Text := ApplicationOpenDialog.FileName;
end;

procedure TSystemOptionsForm.FormShow(Sender: TObject);
begin
  inherited;
  ApplicationEdit.Text := gcwProject.SystemOptions.RefactorOptions.FolderComparisonExe;
  ParamsEdit.Text := gcwProject.SystemOptions.RefactorOptions.FolderComparisonExeParams;
  RefactoringsMemo.Lines := gcwProject.SystemOptions.RefactorOptions.Refactorings;
end;

procedure TSystemOptionsForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ModalResult = mrOk then
  begin
    gcwProject.SystemOptions.RefactorOptions.FolderComparisonExe := ApplicationEdit.Text;
    gcwProject.SystemOptions.RefactorOptions.FolderComparisonExeParams := ParamsEdit.Text;
    gcwProject.SystemOptions.RefactorOptions.Refactorings := RefactoringsMemo.Lines;
    gcwProject.SystemOptions.RefactorOptions.Save(gcwProject.SystemFileSettings);
  end;
end;

procedure TSystemOptionsForm.BrowseRefactoringButtonClick(Sender: TObject);
begin
  if OpenRefactoringDialog.Execute then
    RefactoringsMemo.Lines.Add(OpenRefactoringDialog.FileName);
end;

end.
