(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit ucwColumns;

interface
uses
  Classes, ucwClasses;

type
  TcwColumns = class(TInterfacedObject, IcwColumns)
  private
    FColumns : TInterfaceList;
  public
    constructor Create;
    destructor Destroy;override;

    function GetColumns(Index : Integer) : IcwColumn;
    property Columns[Index : Integer] : IcwColumn read GetColumns;default;

    function GetCount : Integer;
    property Count : Integer read GetCount;

    function AddColumn(const aName : string;const aDataType : TcwDataType) : IcwColumn;
  end;

implementation
uses
  ucwColumn;

constructor TcwColumns.Create;
begin
  inherited ;
  FColumns := TInterfaceList.Create;
end;

destructor  TcwColumns.Destroy;
begin
  FColumns.Free;
  inherited ;
end;

function TcwColumns.GetColumns(Index : Integer) : IcwColumn;
begin
  Result := IcwColumn(FColumns[Index]);
end;

function TcwColumns.GetCount : Integer;
begin
  Result := FColumns.Count;
end;

function TcwColumns.AddColumn(const aName : string;const aDataType : TcwDataType) : IcwColumn;
begin
  Result := TcwColumn.Create(aName, aDataType, FColumns.Count);
  FColumns.Add(Result);
end;

end.
