(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit ucwComponentPrefix;

interface
uses
  Classes, ucwClasses;

type
  TcwComponentPrefix = class(TinterfacedObject, IcwComponentPrefix)
  private
    FPrefix : string;
    FComponentClass : string;
  public
    constructor Create(const aPrefix : string;const aComponentClass : string);

    function GetPrefix : string;
    procedure SetPrefix(const aValue : string);
    property Prefix : string read GetPrefix write SetPrefix;

    function GetComponentClass : string;
    procedure SetComponentClass(const aValue : string);
    property ComponentClass : string read GetComponentClass write SetComponentClass;

  end;

implementation

constructor TcwComponentPrefix.Create(const aPrefix : string;const aComponentClass : string);
begin
  inherited Create;
  FPrefix := aPrefix;
  FComponentClass := aComponentClass;
end;

function TcwComponentPrefix.GetPrefix : string;
begin
  Result := FPrefix;
end;

procedure TcwComponentPrefix.SetPrefix(const aValue : string);
begin
  FPrefix := aValue;
end;

function TcwComponentPrefix.GetComponentClass : string;
begin
  Result := FComponentClass;
end;

procedure TcwComponentPrefix.SetComponentClass(const aValue : string);
begin
  FComponentClass := aValue;
end;

end.
