(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit ucwFind;

interface

type
  IcwFindable = interface
    ['{364D3ED9-800C-427D-9F3A-BCFCE8111604}']
    function Count: Integer;
    function GetString(Value: Integer): string;
    property Strings[Index: Integer]: string read GetString;
  end;

function Find(const AFindable: IcwFindable; AString: string; out AIndex: Integer;
  ACaseSensitive: Boolean): Boolean;

implementation

uses
  SysUtils;

function Find(const AFindable: IcwFindable; AString: string; out AIndex: Integer;
  ACaseSensitive: Boolean): Boolean;

  function CompareStrings(S1, S2: PChar): Integer;
  begin
    if ACaseSensitive then
      Result := StrComp(S1, S2)
    else
      Result := StrIComp(S1, S2);
  end;

var
  L, H, I, C: Integer;
begin
  Result := False;
  L := 0;
  H := AFindable.Count - 1;
  while L <= H do
  begin
    I := (L + H) shr 1;
    C := CompareStrings(PChar(AFindable.Strings[I]), PChar(AString));
    if C < 0 then L := I + 1 else
    begin
      H := I - 1;
      if C = 0 then
      begin
        Result := True;
        //if Duplicates <> dupAccept then L := I;
      end;
    end;
  end;
  AIndex := L;
end;

end.
