(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit ucwPreprocessIntf;

interface

type
  IClUsedUnit = interface
  ['{06B9FE0A-A470-4F3A-8F6A-6DE9A57ABFC0}']

    function GetUnitName: string;
    property UnitName: string
      read GetUnitName;

    function GetFullUnitName: string;
    property FullUnitName: string
      read GetFullUnitName;
  end;

  IClUsedUnitList = interface
  ['{AB95AC2E-AA8A-44CA-80F3-65C1D980205F}']

    function GetItem(aIndex: integer): IClUsedUnit;
    property Items[aIndex : integer]: IClUsedUnit
      read GetItem; default;

    function Add(const UnitName, FullUnitName: string): IClUsedUnit;
    procedure Clear;

    function GetCount: integer;
    property Count: integer
      read GetCount;
  end;

  IClPreProcessorInfo = interface
  ['{B5F0C908-CC7E-4336-8B5C-03D094CA52F5}']

    function GetUsedUnits: IClUsedUnitList;
    property UsedUnits: IClUsedUnitList
      read GetUsedUnits;

    function GetUsedUnitCount: integer;
    property UsedUnitCount: integer
      read GetUsedUnitCount;

    function GetFullUnitName(const aUnitName: string): string;
    property FullUnitName[const aUnitName: string]: string
      read GetFullUnitName;
  end;

function clPreProcessorInfoFactory(const aFilename: string): IClPreProcessorInfo;

implementation

uses
  ucwPreprocessImpl;

// ------------------------------------------------------------------------------------------

function clPreProcessorInfoFactory(const aFilename: string): IClPreProcessorInfo;
begin
  Result := clCreatePreProcessorInfo(aFilename);
end;

// ------------------------------------------------------------------------------------------

end.
