(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit ucwRegExpr;

interface
uses
  Classes, ucwClasses, RegExpr;

type
  //interface for regular expressions
  TcwRegExpr = class(TInterfacedObject, IcwRegExpr)
  private
    FRegExpr : TRegExpr;
  public
    constructor Create;
    destructor Destroy;override;

    //returns the match position
    function  Match(const aRegExpr : string; const aString : string) : Boolean;
  end;

implementation

constructor TcwRegExpr.Create;
begin
  inherited Create;
  FRegExpr := TRegExpr.Create;
end;

destructor TcwRegExpr.Destroy;
begin
  FRegExpr.Free;
  inherited Destroy;
end;


//returns the match position
function  TcwRegExpr.Match(const aRegExpr : string; const aString : string) : Boolean;
begin
  if Length(aRegExpr) = 0 then
    Result := True
  else
  begin
    FRegExpr.Expression := aRegExpr;
    Result := FRegExpr.Exec (aString);
    if Result then
    begin
      Result := (FRegExpr.MatchPos[0] =1) and
                (FRegExpr.MatchLen [0] = Length(aString));
    end;
  end;
end;

end.
