(*  Copyright (c) 2002, the CodeLens project
  All rights reserved.

  Redistribution and use in source and binary forms,
  with or without modification, are permitted provided
  that the following conditions are met:

  Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.

  Redistributions in binary form must reproduce the
  above copyright notice, this list of conditions
  and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
  Neither the name of the CodeLens project nor the names
  of its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
  AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE. *)

unit ucwSetting;

interface
uses
  Classes, ucwClasses;

type
 TcwSetting = class(TInterfacedObject, IcwSetting)
 private
   FName: string;
   FCategory: string;
   FProjectSet : Boolean;
   FLibrarySet : Boolean;

 public
    constructor Create(const aName: string; const aCategory: string;
                       const aDefaultProject : Boolean;
                       const aDefaultLibrary : Boolean);

    function GetName : string;
    property Name: string read GetName;


    function GetCategory : string;
    property Category: string read GetCategory;

    function  GetProjectSet : Boolean;
    procedure SetProjectSet(const aValue : Boolean);
    property  ProjectSet: Boolean read GetProjectSet write SetProjectSet;

    function GetLibrarySet : Boolean;
    procedure SetLibrarySet(const aValue : Boolean);
    property LibrarySet: Boolean read GetLibrarySet write SetLibrarySet;

 end;

implementation


constructor TcwSetting.Create(const aName: string; const aCategory: string;
                              const aDefaultProject : Boolean;
                              const aDefaultLibrary : Boolean);

begin
  inherited Create;
  FName := aName;
  FCategory := aCategory;
  FProjectSet :=  aDefaultProject;
  FLibrarySet :=  aDefaultLibrary;
end;

function TcwSetting.GetName : string;
begin
  Result := FName;
end;


function TcwSetting.GetCategory : string;
begin
  Result := FCategory;
end;

function  TcwSetting.GetProjectSet : Boolean;
begin
  Result := FProjectSet;
end;

procedure TcwSetting.SetProjectSet(const aValue : Boolean);
begin
  FProjectSet := aValue;
end;

function TcwSetting.GetLibrarySet : Boolean;
begin
  Result := FLibrarySet;
end;

procedure TcwSetting.SetLibrarySet(const aValue : Boolean);
begin
  FLibrarySet := aValue;
end;

end.
